package nl.amis.hierarchical.model;

import java.util.ArrayList;
import java.util.List;

public class Continent {
    private String name;
    private String identifier;
    private String mapIdentifier;

    public void setMapIdentifier(String mapIdentifier) {
        this.mapIdentifier = mapIdentifier;
    }

    public String getMapIdentifier() {
        return mapIdentifier;
    }
    private Long population;

    List<Country> countries;

    public void setCountries(List countries) {
        this.countries = countries;
    }

    public Continent(String name, String identifier, String mapIdentifier, Long population) {
        super();
        this.name = name;
        this.identifier = identifier;
        this.population = population;
        this.mapIdentifier = mapIdentifier;
        countries = new ArrayList<Country>();
    }

    public List<Country> getRealCountries() {

        return countries;
    }

    public List<City> getContinentalCities() {
        List<City> cities = new ArrayList<City>();
        for (Country u : countries)
            cities.addAll(u.getRealCities());
        return cities;
    }

    public List<Country> getCountries() {

        List<Country> cs = new ArrayList<Country>();
        cs.addAll(countries);

        Long populationSoFar = 0L;
        // calculate the sum of populations in countries
        for (Country c : countries) {
            populationSoFar = populationSoFar + c.getPopulation();
        }
        // then create an Others country with the continent population minus the sum of country populations as its population
        cs.add(new Country("Others", "others", getPopulation() - populationSoFar));
        return cs;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setIdentifier(String identifier) {
        this.identifier = identifier;
    }

    public String getIdentifier() {
        return identifier;
    }

    public void setPopulation(Long population) {
        this.population = population;
    }

    public Long getPopulation() {
        return population;
    }
}
