package nl.amis.hierarchical.model;

import java.util.ArrayList;
import java.util.List;

public class Country {
    private String name;
    private String identifier;
    private Long population;
    
    private List<City> cities;

    public Country(String name, String identifier, Long population) {
        super();
        this.name = name;
        this.identifier = identifier;
        this.population = population;
        cities = new ArrayList<City>();
    }

    public void setCities(List<City> cities) {
        this.cities = cities;
    }

    public List<City> getRealCities() {
        return cities;
    }

        

        public List<City> getCities() {
            
            List<City> cs = new ArrayList<City>();
            cs.addAll(cities);
            Long populationSoFar = 0L;
            for (City c:cities) {
                populationSoFar=populationSoFar+c.getPopulation();
            }
            // calculate the sum of populations in cities
            // then create an Others city with the country population minus the sum of city populations as its population
             cs.add(new City("Others", "others", getPopulation() - populationSoFar));
            return cs;
        }

    public void setName(String name) {
        this.name = name;
    }
    
    public String getName() {
        return name;
    }
    
    public void setIdentifier(String identifier) {
        this.identifier = identifier;
    }
    
    public String getIdentifier() {
        return identifier;
    }
    
    public void setPopulation(Long population) {
        this.population = population;
    }
    
    public Long getPopulation() {
        return population;
    }}
